Tizen 2.0 Release
[external/tizen-coreutils.git] / tests / chmod / usage
1 #!/bin/sh
2 # Verify that chmod works correctly with odd option combinations.
3
4 # Copyright (C) 2004, 2005, 2006 Free Software Foundation, Inc.
5
6 # This program is free software; you can redistribute it and/or modify
7 # it under the terms of the GNU General Public License as published by
8 # the Free Software Foundation; either version 2 of the License, or
9 # (at your option) any later version.
10
11 # This program is distributed in the hope that it will be useful,
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
14 # GNU General Public License for more details.
15
16 # You should have received a copy of the GNU General Public License
17 # along with this program; if not, write to the Free Software
18 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
19 # 02110-1301, USA.
20
21 if test "$VERBOSE" = yes; then
22   set -x
23   chmod --version
24 fi
25
26 . $srcdir/../lang-default
27
28 pwd=`pwd`
29 t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$
30 trap 'status=$?; cd "$pwd" && chmod -R u+rwx $t0 && rm -rf $t0 && exit $status' 0
31 trap '(exit $?); exit $?' 1 2 13 15
32
33 framework_failure=0
34 mkdir -p $tmp || framework_failure=1
35 cd $tmp || framework_failure=1
36
37 if test $framework_failure = 1; then
38   echo "$0: failure in testing framework" 1>&2
39   (exit 1); exit 1
40 fi
41
42 fail=0
43
44 # Each line in this list is a set of arguments, followed by :,
45 # followed by the set of files it will attempt to chmod,
46 # or empty if the usage is erroneous.
47 # Many of these test cases are due to Glenn Fowler.
48 # These test cases assume GNU behavior for "options" like -w.
49 cases='
50   --         :
51   -- --      :
52   -- -- -- f : -- f
53   -- -- -w f : -w f
54   -- -- f    : f
55   -- -w      :
56   -- -w -- f : -- f
57   -- -w -w f : -w f
58   -- -w f    : f
59   -- f       :
60   -w         :
61   -w --      :
62   -w -- -- f : -- f
63   -w -- -w f : -w f
64   -w -- f    : f
65   -w -w      :
66   -w -w -- f : f
67   -w -w -w f : f
68   -w -w f    : f
69   -w f       : f
70   f          :
71   f --       :
72   f -w       : f
73   f f        :
74   u+gr f     :
75   ug,+x f    :
76 '
77
78 all_files=`echo "$cases" | sed 's/.*://'|sort -u`
79
80 old_IFS=$IFS
81 IFS='
82 '
83 for case in $cases; do
84   IFS=$old_IFS
85   args=`expr "$case" : ' *\(.*[^ ]\) *:'`
86   files=`expr "$case" : '.*: *\(.*\)'`
87
88   case $files in
89   '')
90     touch -- $all_files || framework_failure=1
91     chmod $args 2>/dev/null && fail=1
92     ;;
93   ?*)
94     touch -- $files || framework_failure=1
95     chmod $args || fail=1
96     for file in $files; do
97       # Test for misparsing args by creating all $files but $file.
98       # chmod has a bug if it succeeds even though $file is absent.
99       rm -f -- $all_files && touch -- $files && rm -- $file \
100           || framework_failure=1
101       chmod $args 2>/dev/null && fail=1
102     done
103     ;;
104   esac
105 done
106
107 if test $framework_failure = 1; then
108   echo "$0: failure in testing framework" 1>&2
109   fail=1
110 fi
111
112 (exit $fail); exit $fail